VampArrow = LibStub("AceAddon-3.0"):NewAddon("VampArrow", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceSerializer-3.0")
VampArrow.MINOR_VERSION = tonumber(("$Revision: 34 $"):match("%d+"))
local VampArrow = VampArrow
---

local L

L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "enUS", true)
L["Enable Arrow"] = true
L["Enables the arrow that points toward your vampire target."] = true
L["Toggle Arrow"] = true
L["Shows or hides the arrow, allowing you to move it."] = true
L["%s is biting me!"] = true
L["Biting %s!"] = true
L["Move the arrow"] = true
L["yards"] = true
L["Lock Arrow"] = true
L["Prevents the arrow from moving when you drag it."] = true

L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "deDE")
if L then
L["Biting %s!"] = "Beiße %s!"
L["Enable Arrow"] = "Aktiviert den Pfeil"
L["Enables the arrow that points toward your vampire target."] = "Aktiviert den Pfeil, der in die Richtung deines Vampir Targets zeigt. "
L["Lock Arrow"] = "Sperrt den Pfeil"
L["Move the arrow"] = "Pfeil bewegen"
L["Prevents the arrow from moving when you drag it."] = "Verhindert, dass der Pfeil sich bewegt, wenn man ihn zieht. "
L["Shows or hides the arrow, allowing you to move it."] = "Zeigt oder verbirgt den Pfeil, erlaubt ihn zu bewegen. "
L["%s is biting me!"] = "%s beißt mich!"
L["Toggle Arrow"] = "Pfeil umschalten"
L["yards"] = "Yards"

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "esES")
if L then
L["Biting %s!"] = "Mordiendo a"
L["Enable Arrow"] = "Habilitar flecha"
L["Enables the arrow that points toward your vampire target."] = "Habilita la flecha que marca a quién tienes que morder"
L["Lock Arrow"] = "Bloquear flecha"
L["Move the arrow"] = "Mover la flecha"
L["Prevents the arrow from moving when you drag it."] = "Evita que se mueva la flecha al arrastrarla"
L["Shows or hides the arrow, allowing you to move it."] = "Muestra o esconde la flecha, permitiéndote moverla"
L["%s is biting me!"] = "me está mordiendo!"
L["Toggle Arrow"] = "Hab/Deshab flecha"
L["yards"] = "yardas"

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "esMX")
if L then
-- L["Biting %s!"] = ""
-- L["Enable Arrow"] = ""
-- L["Enables the arrow that points toward your vampire target."] = ""
-- L["Lock Arrow"] = ""
-- L["Move the arrow"] = ""
-- L["Prevents the arrow from moving when you drag it."] = ""
-- L["Shows or hides the arrow, allowing you to move it."] = ""
-- L["%s is biting me!"] = ""
-- L["Toggle Arrow"] = ""
-- L["yards"] = ""

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "frFR")
if L then
L["Biting %s!"] = "Mordez %s!"
L["Enable Arrow"] = "Activer la Flèche"
L["Enables the arrow that points toward your vampire target."] = "Active la flèche pointant vers votre cible vampire."
L["Lock Arrow"] = "Verrouille la Flèche"
L["Move the arrow"] = "Déplace la flèche"
L["Prevents the arrow from moving when you drag it."] = "Empêche la flèche de se déplacer lorsque vous la tirez."
L["Shows or hides the arrow, allowing you to move it."] = "Affiche ou masque la flèche, vous permettant de la déplacer."
L["%s is biting me!"] = "%s me mord!"
L["Toggle Arrow"] = "Cache la Flèche"
L["yards"] = true

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "koKR")
if L then
L["Biting %s!"] = "%s 물음!"
L["Enable Arrow"] = "화살표 사용"
L["Enables the arrow that points toward your vampire target."] = "당신이 물어야 할 대상을 화살표로 표시"
L["Lock Arrow"] = "화살표 잠금"
L["Move the arrow"] = "화살표 이동"
L["Prevents the arrow from moving when you drag it."] = "화살표를 잘못 드래그하여 이동되지 않도록 합니다."
L["Shows or hides the arrow, allowing you to move it."] = "화살표의 위치를 이동 / 보임 / 숨김"
L["%s is biting me!"] = "%s 에게 물림!"
L["Toggle Arrow"] = "화살표 토글"
L["yards"] = "미터"

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "ruRU")
if L then
L["Biting %s!"] = "Кусаем %s!"
L["Enable Arrow"] = "Вкл. Указатели"
L["Enables the arrow that points toward your vampire target."] = "Включает стрелку, указывающую направление к цели вампира."
L["Lock Arrow"] = "Зафиксировать стрелку"
L["Move the arrow"] = "Двигайте стрелку"
L["Prevents the arrow from moving when you drag it."] = "Не дает стрелке перемещаться при перетаскивании."
L["Shows or hides the arrow, allowing you to move it."] = "Показывает или прячет стрелку, позволяя вам передвигать ее."
L["%s is biting me!"] = "%s кусает меня!"
L["Toggle Arrow"] = "Вкл/выкл стрелку"
L["yards"] = "метр(ов)"

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "zhCN")
if L then
L["Biting %s!"] = "咬%s！"
L["Enable Arrow"] = "开启箭头"
L["Enables the arrow that points toward your vampire target."] = "开启咬人目标的箭头指示。"
L["Lock Arrow"] = "锁定箭头"
L["Move the arrow"] = "移动箭头"
L["Prevents the arrow from moving when you drag it."] = "当您拖动箭头时防止箭头移动。"
L["Shows or hides the arrow, allowing you to move it."] = "显示或隐藏箭头，允许移动。"
L["%s is biting me!"] = "%s正在咬我！"
L["Toggle Arrow"] = "切换箭头"
L["yards"] = "码"

end
L = LibStub("AceLocale-3.0"):NewLocale("VampArrow", "zhTW")
if L then
L["Biting %s!"] = "咬 %s!"
L["Enable Arrow"] = "開啟箭頭指示"
L["Enables the arrow that points toward your vampire target."] = "開啟咬人目標的箭頭指示"
L["Lock Arrow"] = "鎖定箭頭"
L["Move the arrow"] = "移動箭頭"
L["Prevents the arrow from moving when you drag it."] = "當您拖動箭頭時防止箭頭移動"
L["Shows or hides the arrow, allowing you to move it."] = "顯示或隱藏箭頭，允許移動"
L["%s is biting me!"] = "要咬我的是 %s!"
L["Toggle Arrow"] = "開關箭頭指示"
L["yards"] = "碼"

end

L = LibStub("AceLocale-3.0"):GetLocale("VampArrow")



--[[-- MISTS OF PANDARIA RAID/PARTY API COMPATIBILITY LAYER --------------------------------------------------------------------]]

local IsRaidLeader = _G.IsRaidLeader
local IsPartyLeader = _G.IsPartyLeader
local UnitIsPartyLeader = _G.UnitIsPartyLeader
if UnitIsGroupLeader ~= nil then
 IsRaidLeader = function(unit) if UnitIsGroupLeader(unit) then return 1 else return nil end end
 IsPartyLeader = function(unit) if UnitIsGroupLeader(unit) then return 1 else return nil end end
 UnitIsPartyLeader = function(unit) if UnitIsGroupLeader(unit) then return 1 else return nil end end
end
local GetNumPartyMembers = _G.GetNumPartyMembers
local GetRealNumPartyMembers = _G.GetRealNumPartyMembers
if GetNumSubgroupMembers ~= nil then
 GetNumPartyMembers = function() return GetNumSubgroupMembers() end
 GetRealNumPartyMembers = function() return GetNumSubgroupMembers(LE_PARTY_CATEGORY_HOME) end
end
local GetNumRaidMembers = _G.GetNumRaidMembers
local GetRealNumRaidMembers = _G.GetRealNumRaidMembers
if GetNumGroupMembers ~= nil then
 GetNumRaidMembers = function() return GetNumGroupMembers() end
 GetRealNumRaidMembers = function() return GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) end
end


local assignment
local vampireDebuff = GetSpellInfo(70867) -- Essence of the Blood Queen
local mindControlledDebuff = GetSpellInfo(70923) -- Uncontrollable Frenzy
local testDebuff
--[===[@debug@
testDebuff = 58600 -- Restricted Flight Area
--@end-debug@]===]
local commPrefix = "VampArrow-1.0"
local arrowMoving = false


local newOrder
do
	local current = 0
	function newOrder()
		current = current + 1
		return current
	end
end


VampArrow.defaults = {
 profile = {
		enableArrow = true,
		arrowPosX = 0,
		arrowPosY = -150,
		arrowPoint = "TOP",
		lockArrow = false,
 },
}


VampArrow.options = {
	name = "VampArrow         r|cff20ff20"..VampArrow.MINOR_VERSION.."|r",
	handler = VampArrow,
	type = "group",
	childGroups = "tab",
	args = {		

		enableArrow = {
			type = "toggle",
			name = L["Enable Arrow"],
			desc = L["Enables the arrow that points toward your vampire target."],
			get = function() return VampArrow.db.profile.enableArrow end,
			set = function(self, val) VampArrow.db.profile.enableArrow = val end,
			order = newOrder(),
		}, -- enableArrow

		toggleArrow = {
			type = "execute",
			name = L["Toggle Arrow"],
			desc = L["Shows or hides the arrow, allowing you to move it."],
			func = function(self)
				if arrowMoving then
					arrowMoving = false
					VampArrow.Arrow:EndMove()
				else
					arrowMoving = true
					VampArrow.Arrow:Move()
				end
			end,
			order = newOrder(),
		}, -- toggleArrow

		lockArrow = {
			type = "toggle",
			name = L["Lock Arrow"],
			desc = L["Prevents the arrow from moving when you drag it."],
			get = function() return VampArrow.db.profile.lockArrow end,
			set = function(self, val) VampArrow.db.profile.lockArrow = val end,
			order = newOrder(),
		}, -- lockArrow

	}
}


function VampArrow:OnInitialize()
 self.db = LibStub("AceDB-3.0"):New("VampArrowDB", self.defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("VampArrow", VampArrow.options)
	VampArrow.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VampArrow", "VampArrow")
	self:RegisterChatCommand("vamparrow", "ChatCommand")
	
	VampArrow:RegisterMapSize("IcecrownCitadel", 6, 373.70996094, 249.12988281)
	--[===[@debug@
	VampArrow:RegisterMapSize("Dalaran", 0, 0.0, 0.0)
	VampArrow:RegisterMapSize("Moonglade", 0, 2308.33325195313, 1539.5830078125)
	--@end-debug@]===]
end


function VampArrow:OnEnable()
 self:RegisterComm(commPrefix, "OnCommReceived")
	VampArrow.Arrow:LoadPosition()
	--[===[@debug@
	self:Print("Loaded")
	--@end-debug@]===]
end


function VampArrow:ChatCommand(input)
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end


function VampArrow:OnCommReceived(prefix, message, distribution, sender)
 local success, o = self:Deserialize(message)
 if success == false then
		--[===[@debug@
  self:Print("[OnCommReceived] Failed to deserialize message")
		--@end-debug@]===]
  return
 else
		if o.c then
			if o.c == "SET" then
				if o.t then
					self:SetTarget(o.t, o.a or false, o.r or false, o.m, o.dm or false)
				end
			elseif o.c == "VER_REQ" then
				self:SendCommMessage(commPrefix, self:Serialize({ c = "VER", v = self.MINOR_VERSION }), "WHISPER", sender)				
			end
		end
 end
end


function VampArrow:UpdateRaid()
	if not UnitInRaid("player") then return end
	for i = 1, GetNumRaidMembers() do
		local playerName, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
		if playerName and (not online or isDead) then
			if playerName == UnitName("player") or (assignment and playerName == assignment) then
				self:ClearTarget()
			end
		end
	end
end


function VampArrow:ClearTarget()
	assignment = nil
	VampArrow.Arrow.mark = nil
	VampArrow.Arrow:EndMove()
	if HudMap then self:FreeEncounterMarkers() end
	self:UnregisterAllEvents()
end


local encounterMarkers = {}
function VampArrow:RegisterEncounterMarker(e)
	encounterMarkers[e] = true
	e.RegisterCallback(self, "Free", "FreeEncounterMarker")
end


function VampArrow:FreeEncounterMarker(e)
	encounterMarkers[e] = nil
end


function VampArrow:FreeEncounterMarkers()
	for k, _ in pairs(encounterMarkers) do
		encounterMarkers[k] = k:Free()
	end
end


local function register(e)	
	VampArrow:RegisterEncounterMarker(e)
	return e
end


function VampArrow:SetTarget(target, announce, reverse, mark, doMark)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "UpdateRaid")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "ClearTarget")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "ClearTarget")

	if not announce then announce = false end
	if not reverse then reverse = false end
	
	assignment = target
	
	VampArrow.Arrow.mark = nil
	if mark and doMark then
		VampArrow.Arrow.mark = mark
	end
	
	if self.db.profile.enableArrow then
		VampArrow.Arrow:ShowRunTo(target)
	end
	
	if HudMap then
		local radius, seconds, r, g, b, a = 5.0, 75, 1.0, 1.0, 1.0, 0.6
		register(HudMap:PlaceRangeMarkerOnPartyMember("highlight", target, radius, seconds, r, g, b, a):Rotate(360, 2):SetLabel(target))
	end
	
	if target and announce then
		if reverse then
			SendChatMessage(format(L["Biting %s!"], target), "YELL")
		else
			SendChatMessage(format(L["%s is biting me!"], target), "YELL")
		end
	end
end


function VampArrow:OnCombatEvent(event, timestamp, eventType, hideCaster, srcGuid, srcName, srcFlags, srcRaidFlags, dstGuid, dstName, dstFlags, dstRaidFlags, ...)
	if eventType == "SPELL_AURA_APPLIED" then
		if (srcName == UnitName("player") or dstName == UnitName("player")) or (assignment and (srcName == assignment or dstName == assignment)) then
			local spellId, spellName, spellSchool, auraType = select(1, ...)
			if spellName == vampireDebuff or spellName == mindControlledDebuff or spellId == testDebuff then
				self:ClearTarget()
			end
		end
	end
end
